import sys
from quixote.errors import TraversalError

def fact(n):
    f = 1L
    while n > 1:
        f *= n
        n -= 1
    return f

class IntegerUI:

    _q_exports = ["factorial"]

    def __init__(self, request, component):
        try:
            self.n = int(component)
        except ValueError, exc:
            raise TraversalError(str(exc))
    
    def factorial(self, request):
        if self.n > 10000:
            sys.stderr.write("warning: possible denial-of-service attack "
                             "(request for factorial(%d))\n" % self.n)
        request.response.set_header("content-type", "text/plain")
        return "%d! = %d\n" % (self.n, fact(self.n))
        
    def _q_index(self, request):
        return """\
<html>
<head><title>The Number %d</title></head>
<body>
You have selected the integer %d.<p>

You can compute its <a href="factorial">factorial</a> (%d!)<p>

Or, you can visit the web page for the
<a href="../%d/">previous</a> or
<a href="../%d/">next</a> integer.<p>
</body>
</html>
""" % (self.n, self.n, self.n, self.n-1, self.n+1)
